diff --git a/drivers/video/sunxi/lcd_fb/disp_lcd.c b/drivers/video/sunxi/lcd_fb/disp_lcd.c
index 9cf693c1d..edf50646a 100644
--- a/drivers/video/sunxi/lcd_fb/disp_lcd.c
+++ b/drivers/video/sunxi/lcd_fb/disp_lcd.c
@@ -1553,7 +1812,7 @@ static s32 disp_lcd_init(struct lcd_fb_device *lcd)
 			duty_ns = (backlight_bright * period_ns) / 256;
 			lcdp->pwm_info.duty_ns = duty_ns;
 			lcdp->pwm_info.period_ns = period_ns;
-			disp_lcd_backlight_register(lcd);
+			sunxi_lcd_fb_disp_lcd_backlight_register(lcd);
 		}
 		for (i = 0; i < 256; i++) {
 			lcdp->panel_extend_info.lcd_gamma_tbl[i] =
@@ -1565,40 +1824,44 @@ static s32 disp_lcd_init(struct lcd_fb_device *lcd)
 
 			memcpy(&gpio_info, &(lcdp->lcd_cfg.lcd_gpio[i]),
 			       sizeof(struct disp_gpio_info));
-			lcd_fb_gpio_request(&gpio_info);
+			sunxi_lcd_fb_gpio_request(&gpio_info);
 		}
 	}
 
 	return 0;
 }
 
-
-
-static s32 disp_lcd_exit(struct lcd_fb_device *lcd)
+static s32 sunxi_lcd_fb_disp_lcd_exit(struct sunxi_lcd_fb_device *lcd)
 {
-	struct disp_lcd_private_data *lcdp = disp_lcd_get_priv(lcd);
+	struct disp_lcd_private_data *lcdp =
+		sunxi_lcd_fb_disp_lcd_get_priv(lcd);
 
-	if ((lcd == NULL) || (lcdp == NULL)) {
-		lcd_fb_wrn("NULL hdl!\n");
+	if (lcd == NULL) {
+		LCDFB_WRN("lcd handle is NULL!\n");
 		return -1;
 	}
 
-	if (lcdp->panel_info.lcd_pwm_used) {
-		disp_lcd_backlight_unregister(lcd);
-		lcd_fb_pwm_free(lcdp->pwm_info.dev);
+	if (lcdp == NULL) {
+		LCDFB_WRN("lcdp handle is NULL!\n");
+		return -1;
 	}
 
+	if (lcdp->panel_info.lcd_pwm_used) {
+		sunxi_lcd_fb_disp_lcd_backlight_unregister(lcd);
+		sunxi_lcd_fb_pwm_free(lcdp->pwm_info.dev);
+	}
 
 	return 0;
 }
 
-s32 disp_lcd_get_resolution(struct lcd_fb_device *dispdev, u32 *xres,
-			       u32 *yres)
+s32 sunxi_lcd_fb_disp_lcd_get_resolution(struct sunxi_lcd_fb_device *dispdev,
+					 u32 *xres, u32 *yres)
 {
-	struct disp_lcd_private_data *lcdp = disp_lcd_get_priv(dispdev);
+	struct disp_lcd_private_data *lcdp =
+		sunxi_lcd_fb_disp_lcd_get_priv(dispdev);
 
 	if (dispdev == NULL) {
-		lcd_fb_wrn("NULL hdl!\n");
+		LCDFB_WRN("NULL hdl!\n");
 		return -1;
 	}
 
@@ -1611,28 +1874,32 @@ s32 disp_lcd_get_resolution(struct lcd_fb_device *dispdev, u32 *xres,
 	return 0;
 }
 
-static int disp_lcd_panel_dma_transfer(struct lcd_fb_device *p_lcd, void *buf,
-				       unsigned int len)
+static int
+sunxi_lcd_fb_disp_lcd_panel_dma_transfer(struct sunxi_lcd_fb_device *p_lcd,
+					 void *buf, u32 len)
 {
 	struct spi_transfer t;
 	int ret = 0;
 	struct spi_device *spi_device;
+#if defined(SUPPORT_DBI_IF)
 	struct sunxi_dbi_config dbi_config;
-	struct disp_lcd_private_data *lcdp = disp_lcd_get_priv(p_lcd);
+	struct disp_lcd_private_data *lcdp =
+		sunxi_lcd_fb_disp_lcd_get_priv(p_lcd);
+#endif
 
 	if (!p_lcd || !p_lcd->spi_device)
 		return -1;
 
 	spi_device = p_lcd->spi_device;
 	if (spi_device == NULL)
-		lcd_fb_wrn("\n");
+		LCDFB_WRN("\n");
 
 	memset(&t, 0, sizeof(t));
 
 #if defined(SUPPORT_DBI_IF)
 	memset(&dbi_config, 0, sizeof(dbi_config));
 	if (lcdp->panel_info.lcd_if == LCD_FB_IF_DBI) {
-		spi_dbi_config_init(lcdp, &dbi_config);
+		sunxi_lcd_fb_spi_dbi_config_init(lcdp, &dbi_config);
 		DBI_WRITE(dbi_config.dbi_mode);
 		DBI_MSB_FIRST(dbi_config.dbi_mode);
 		DBI_TR_VIDEO(dbi_config.dbi_mode);
@@ -1652,23 +1919,121 @@ static int disp_lcd_panel_dma_transfer(struct lcd_fb_device *p_lcd, void *buf,
 	return ret;
 }
 
-static s32 _spi_dc_pin_set(struct disp_lcd_private_data *lcdp, u32 data)
+static int
+sunxi_lcd_fb_disp_qspi_lcd_panel_dma_transfer(struct sunxi_lcd_fb_device *p_lcd,
+					      void *buf, u32 len)
+{
+	struct spi_message msg;
+	struct spi_transfer tr[2];
+	struct spi_device *spi_device;
+	int ret;
+	unsigned char addr_buf[4] = { 0xA2, 0x00, 0x2c, 0x00 };
+	struct disp_lcd_private_data *lcdp =
+		sunxi_lcd_fb_disp_lcd_get_priv(p_lcd);
+
+	if (!p_lcd || !p_lcd->spi_device)
+		return -1;
+
+	spi_device = p_lcd->spi_device;
+	if (spi_device == NULL)
+		LCDFB_WRN("\n");
+
+	memset(&tr, 0, sizeof(struct spi_transfer) * 2);
+
+	if (lcdp->panel_info.qspi_if == LCD_FB_QSPI_LANE2) {
+		addr_buf[0] = 0xA2;
+
+		spi_device->mode |= SPI_TX_DUAL;
+		// First transfer: addr_buf with tx_nbits = 1
+		tr[0].tx_buf = addr_buf;
+		tr[0].rx_buf = NULL;
+		tr[0].len = sizeof(addr_buf);
+		tr[0].speed_hz = spi_device->max_speed_hz;
+		tr[0].tx_nbits = SPI_NBITS_SINGLE; // tx_nbits = 1
+
+		// Second transfer: buf with tx_nbits = 2
+		tr[1].tx_buf = buf;
+		tr[1].rx_buf = NULL;
+		tr[1].len = len;
+		tr[1].speed_hz = spi_device->max_speed_hz;
+		tr[1].tx_nbits = SPI_NBITS_DUAL; // tx_nbits = 2
+
+		spi_message_init(&msg);
+		spi_message_add_tail(&tr[0], &msg);
+		spi_message_add_tail(&tr[1], &msg);
+
+		ret = spi_sync(spi_device, &msg);
+		spi_device->mode &= ~SPI_TX_DUAL;
+	} else if (lcdp->panel_info.qspi_if == LCD_FB_QSPI_LANE4) {
+		addr_buf[0] = 0x32;
+
+		spi_device->mode |= SPI_TX_QUAD;
+		// First transfer: addr_buf with tx_nbits = 1
+		tr[0].tx_buf = addr_buf;
+		tr[0].rx_buf = NULL;
+		tr[0].len = sizeof(addr_buf);
+		tr[0].speed_hz = spi_device->max_speed_hz;
+		tr[0].tx_nbits = SPI_NBITS_SINGLE; // tx_nbits = 1
+
+		// Second transfer: buf with tx_nbits = 4
+		tr[1].tx_buf = buf;
+		tr[1].rx_buf = NULL;
+		tr[1].len = len;
+		tr[1].speed_hz = spi_device->max_speed_hz;
+		tr[1].tx_nbits = SPI_NBITS_QUAD; // tx_nbits = 4
+
+		spi_message_init(&msg);
+		spi_message_add_tail(&tr[0], &msg);
+		spi_message_add_tail(&tr[1], &msg);
+
+		ret = spi_sync(spi_device, &msg);
+		spi_device->mode &= ~SPI_TX_QUAD;
+	} else {
+		addr_buf[0] = 0x02;
+
+		// First transfer: addr_buf with tx_nbits = 1
+		tr[0].tx_buf = addr_buf;
+		tr[0].rx_buf = NULL;
+		tr[0].len = sizeof(addr_buf);
+		tr[0].speed_hz = spi_device->max_speed_hz;
+		tr[0].tx_nbits = SPI_NBITS_SINGLE; // tx_nbits = 1
+
+		// Second transfer: buf with tx_nbits = 1
+		tr[1].tx_buf = buf;
+		tr[1].rx_buf = NULL;
+		tr[1].len = len;
+		tr[1].speed_hz = spi_device->max_speed_hz;
+		tr[1].tx_nbits = SPI_NBITS_SINGLE; // tx_nbits = 1
+
+		spi_message_init(&msg);
+		spi_message_add_tail(&tr[0], &msg);
+		spi_message_add_tail(&tr[1], &msg);
+
+		ret = spi_sync(spi_device, &msg);
+	}
+	return ret;
+}
+
+static s32 sunxi_lcd_fb_spi_dc_pin_set(struct disp_lcd_private_data *lcdp,
+				       u32 data)
 {
 	if (!lcdp)
 		goto OUT;
 
 	if (strlen(lcdp->lcd_cfg.lcd_spi_dc_pin.name))
-		return lcd_fb_gpio_set_value(lcdp->lcd_cfg.lcd_spi_dc_pin.gpio, data,
-					     "lcd_spi_dc_pin");
+		return sunxi_lcd_fb_gpio_set_value(
+			lcdp->lcd_cfg.lcd_spi_dc_pin.gpio, data,
+			"lcd_spi_dc_pin");
 OUT:
 	return -1;
 }
 
-int disp_lcd_wait_for_vsync(struct lcd_fb_device *p_lcd)
+int sunxi_lcd_fb_disp_lcd_wait_for_vsync(struct sunxi_lcd_fb_device *p_lcd)
 {
 	unsigned long count;
 	int ret = -1;
-	struct disp_lcd_private_data *lcdp = disp_lcd_get_priv(p_lcd);
+	struct disp_lcd_private_data *lcdp =
+		sunxi_lcd_fb_disp_lcd_get_priv(p_lcd);
 
 	count = lcdp->wait_count;
 
@@ -1676,18 +2041,20 @@ int disp_lcd_wait_for_vsync(struct lcd_fb_device *p_lcd)
 		goto OUT;
 
 	ret = wait_event_interruptible_timeout(
-	    lcdp->wait, count != lcdp->wait_count, msecs_to_jiffies(50));
+		lcdp->wait, count != lcdp->wait_count, msecs_to_jiffies(50));
 
 OUT:
 	return ret;
 }
 
-int disp_lcd_set_layer(struct lcd_fb_device *lcd, struct fb_info *p_info)
+int sunxi_lcd_fb_disp_spi_lcd_set_layer(struct sunxi_lcd_fb_device *lcd,
+					struct fb_info *p_info)
 {
 	int ret = -1;
-	unsigned int i = 0, len = 0;
+	u32 i = 0, len = 0;
 	unsigned char *addr = NULL, *end_addr = NULL;
-	struct disp_lcd_private_data *lcdp = disp_lcd_get_priv(lcd);
+	struct disp_lcd_private_data *lcdp =
+		sunxi_lcd_fb_disp_lcd_get_priv(lcd);
 
 	mutex_lock(&lcdp->layer_mlock);
 
@@ -1696,15 +2063,54 @@ int disp_lcd_set_layer(struct lcd_fb_device *lcd, struct fb_info *p_info)
 
 	if (p_info) {
 		addr = (unsigned char *)p_info->screen_base +
-			p_info->var.yoffset * p_info->fix.line_length;
+		       p_info->var.yoffset * p_info->fix.line_length;
 		end_addr = (unsigned char *)addr + p_info->fix.smem_len;
 		for (i = 0; i < p_info->var.yres &&
-		     addr <= end_addr - p_info->fix.line_length;
+			    addr <= end_addr - p_info->fix.line_length;
+		     i += lcdp->panel_info.lines_per_transfer) {
+			ret = sunxi_lcd_fb_disp_lcd_panel_dma_transfer(
+				lcd, (void *)addr, len);
+			addr = (unsigned char *)addr +
+			       p_info->fix.line_length *
+				       lcdp->panel_info.lines_per_transfer;
+		}
+	}
+
+	mutex_unlock(&lcdp->layer_mlock);
+	return ret;
+}
+
+int sunxi_lcd_fb_disp_qspi_lcd_set_layer(struct sunxi_lcd_fb_device *lcd,
+					 struct fb_info *p_info)
+{
+	static int spi_line_lenth;
+	int ret = -1;
+	unsigned int i = 0, len = 0;
+	unsigned char *addr = NULL, *end_addr = NULL;
+	struct disp_lcd_private_data *lcdp =
+		sunxi_lcd_fb_disp_lcd_get_priv(lcd);
+
+	mutex_lock(&lcdp->layer_mlock);
+
+	if (!spi_line_lenth)
+		spi_line_lenth =
+			p_info->var.xres_virtual * lcdp->panel_info.bpp;
+
+	len = spi_line_lenth;
+	len *= lcdp->panel_info.lines_per_transfer;
+
+	if (p_info) {
+		addr = (unsigned char *)p_info->screen_base +
+		       p_info->var.yoffset * p_info->fix.line_length;
+		end_addr = (unsigned char *)addr + p_info->fix.smem_len;
+		for (i = 0;
+		     i < p_info->var.yres && addr <= end_addr - spi_line_lenth;
 		     i += lcdp->panel_info.lines_per_transfer) {
-			ret = disp_lcd_panel_dma_transfer(lcd, (void *)addr, len);
+			ret = sunxi_lcd_fb_disp_qspi_lcd_panel_dma_transfer(
+				lcd, (void *)addr, len);
 			addr = (unsigned char *)addr +
-				p_info->fix.line_length *
-				lcdp->panel_info.lines_per_transfer;
+			       spi_line_lenth *
+				       lcdp->panel_info.lines_per_transfer;
 		}
 	}
 
@@ -1712,10 +2118,12 @@ int disp_lcd_set_layer(struct lcd_fb_device *lcd, struct fb_info *p_info)
 	return ret;
 }
 
-int disp_lcd_set_var(struct lcd_fb_device *lcd, struct fb_info *p_info)
+int sunxi_lcd_fb_disp_lcd_set_var(struct sunxi_lcd_fb_device *lcd,
+				  struct fb_info *p_info)
 {
 	int ret = -1;
-	struct disp_lcd_private_data *lcdp = disp_lcd_get_priv(lcd);
+	struct disp_lcd_private_data *lcdp =
+		sunxi_lcd_fb_disp_lcd_get_priv(lcd);
 
 	mutex_lock(&lcdp->layer_mlock);
 	if (lcdp->lcd_panel_fun.set_var && p_info)
@@ -1724,22 +2132,28 @@ int disp_lcd_set_var(struct lcd_fb_device *lcd, struct fb_info *p_info)
 	return ret;
 }
 
-int disp_lcd_blank(struct lcd_fb_device *lcd, unsigned int en)
+int sunxi_lcd_fb_disp_lcd_blank(struct sunxi_lcd_fb_device *lcd, u32 en)
 {
 	int ret = -1;
-	struct disp_lcd_private_data *lcdp = disp_lcd_get_priv(lcd);
+	struct disp_lcd_private_data *lcdp =
+		sunxi_lcd_fb_disp_lcd_get_priv(lcd);
 
 	if (lcdp->lcd_panel_fun.blank)
 		ret = lcdp->lcd_panel_fun.blank(lcd->disp, en);
 	return ret;
 }
 
-static int disp_lcd_cmd_read(struct lcd_fb_device *p_lcd, unsigned char cmd,
-		unsigned char *rx_buf, unsigned char len)
+static int sunxi_lcd_fb_disp_lcd_cmd_read(struct sunxi_lcd_fb_device *p_lcd,
+					  unsigned char cmd,
+					  unsigned char *rx_buf,
+					  unsigned char len)
 {
 	struct spi_transfer t;
+#if defined(SUPPORT_DBI_IF)
 	struct sunxi_dbi_config dbi_config;
-	struct disp_lcd_private_data *lcdp = disp_lcd_get_priv(p_lcd);
+	struct disp_lcd_private_data *lcdp =
+		sunxi_lcd_fb_disp_lcd_get_priv(p_lcd);
+#endif
 
 	if (!p_lcd || !p_lcd->spi_device)
 		return -1;
@@ -1748,15 +2162,15 @@ static int disp_lcd_cmd_read(struct lcd_fb_device *p_lcd, unsigned char cmd,
 #if defined(SUPPORT_DBI_IF)
 	memset(&dbi_config, 0, sizeof(dbi_config));
 	if (lcdp->panel_info.lcd_if == LCD_FB_IF_DBI) {
-		spi_dbi_config_init(lcdp, &dbi_config);
+		sunxi_lcd_fb_spi_dbi_config_init(lcdp, &dbi_config);
 		DBI_READ(dbi_config.dbi_mode);
 		DBI_MSB_FIRST(dbi_config.dbi_mode);
 		DBI_TR_COMMAND(dbi_config.dbi_mode);
 		DBI_DCX_COMMAND(dbi_config.dbi_mode);
-		dbi_config.dbi_format = 0;	/* must set rgb111 */
+		dbi_config.dbi_format = 0; /* must set rgb111 */
 		dbi_config.dbi_cmd_data = cmd;
-		dbi_config.dbi_read_bytes = len;	/* read 1 number */
-		dbi_config.dbi_read_dummy = 2;  /* read 2 dummy, modifiable */
+		dbi_config.dbi_read_bytes = len; /* read 1 number */
+		dbi_config.dbi_read_dummy = 2; /* read 2 dummy, modifiable */
 		sunxi_dbi_set_config(p_lcd->spi_device, &dbi_config);
 
 		t.rx_buf = rx_buf;
@@ -1772,11 +2186,53 @@ static int disp_lcd_cmd_read(struct lcd_fb_device *p_lcd, unsigned char cmd,
 	}
 }
 
-static int disp_lcd_para_write(struct lcd_fb_device *p_lcd, unsigned char para)
+static int
+sunxi_lcd_fb_disp_qspi_lcd_cmd_read(struct sunxi_lcd_fb_device *p_lcd,
+				    unsigned char cmd, unsigned char *rx_buf,
+				    unsigned char len)
+{
+	struct spi_message msg;
+	struct spi_transfer tr[2];
+	struct disp_lcd_private_data *lcdp =
+		sunxi_lcd_fb_disp_lcd_get_priv(p_lcd);
+	unsigned char addr_buf[5] = { 0x0B, 0x00, cmd, 0x00, 0x00 };
+
+	if (!p_lcd || !p_lcd->spi_device)
+		return -1;
+
+	memset(&tr, 0, sizeof(struct spi_transfer) * 2);
+
+	sunxi_lcd_fb_spi_dc_pin_set(lcdp, 1);
+
+	tr[0].tx_buf = addr_buf;
+	tr[0].rx_buf = NULL;
+	tr[0].len = 5;
+	tr[0].speed_hz = 5000000;
+	tr[0].tx_nbits = 1;
+	tr[0].rx_nbits = 1;
+
+	tr[1].tx_buf = NULL;
+	tr[1].rx_buf = rx_buf;
+	tr[1].len = len;
+	tr[1].speed_hz = 5000000;
+	tr[1].tx_nbits = 1;
+	tr[1].rx_nbits = 1;
+
+	spi_message_init(&msg);
+	spi_message_add_tail(&tr[0], &msg);
+	spi_message_add_tail(&tr[1], &msg);
+	return spi_sync(p_lcd->spi_device, &msg);
+}
+
+static int sunxi_lcd_fb_disp_lcd_para_write(struct sunxi_lcd_fb_device *p_lcd,
+					    unsigned char para)
 {
 	struct spi_transfer t;
+#if defined(SUPPORT_DBI_IF)
 	struct sunxi_dbi_config dbi_config;
-	struct disp_lcd_private_data *lcdp = disp_lcd_get_priv(p_lcd);
+#endif
+	struct disp_lcd_private_data *lcdp =
+		sunxi_lcd_fb_disp_lcd_get_priv(p_lcd);
 
 	if (!p_lcd || !p_lcd->spi_device)
 		return -1;
@@ -1785,17 +2241,17 @@ static int disp_lcd_para_write(struct lcd_fb_device *p_lcd, unsigned char para)
 #if defined(SUPPORT_DBI_IF)
 	memset(&dbi_config, 0, sizeof(dbi_config));
 	if (lcdp->panel_info.lcd_if == LCD_FB_IF_DBI) {
-		spi_dbi_config_init(lcdp, &dbi_config);
+		sunxi_lcd_fb_spi_dbi_config_init(lcdp, &dbi_config);
 		DBI_WRITE(dbi_config.dbi_mode);
 		DBI_MSB_FIRST(dbi_config.dbi_mode);
 		DBI_TR_COMMAND(dbi_config.dbi_mode);
-		dbi_config.dbi_format = 0;	/* must set rgb111 */
+		dbi_config.dbi_format = 0; /* must set rgb111 */
 		DBI_DCX_DATA(dbi_config.dbi_mode);
 		sunxi_dbi_set_config(p_lcd->spi_device, &dbi_config);
 	} else
 #endif
 	{
-		_spi_dc_pin_set(lcdp, 1);
+		sunxi_lcd_fb_spi_dc_pin_set(lcdp, 1);
 	}
 
 	t.tx_buf = &para;
@@ -1805,11 +2261,86 @@ static int disp_lcd_para_write(struct lcd_fb_device *p_lcd, unsigned char para)
 	return spi_sync_transfer(p_lcd->spi_device, &t, 1);
 }
 
-static int disp_lcd_cmd_write(struct lcd_fb_device *p_lcd, unsigned char cmd)
+static int
+sunxi_lcd_fb_disp_qspi_lcd_para_write(struct sunxi_lcd_fb_device *p_lcd,
+				      unsigned char cmd, unsigned char para)
+{
+	struct spi_message msg;
+	struct spi_transfer tr[2];
+	struct disp_lcd_private_data *lcdp =
+		sunxi_lcd_fb_disp_lcd_get_priv(p_lcd);
+	unsigned char addr_buf[4] = { 0x02, 0x00, cmd, 0x00 };
+
+	if (!p_lcd || !p_lcd->spi_device)
+		return -1;
+
+	memset(&tr, 0, sizeof(struct spi_transfer) * 2);
+
+	sunxi_lcd_fb_spi_dc_pin_set(lcdp, 1);
+
+	tr[0].tx_buf = addr_buf;
+	tr[0].len = 4;
+	tr[0].speed_hz = 10000000;
+	tr[0].tx_nbits = 1;
+	tr[0].rx_nbits = 1;
+
+	tr[1].tx_buf = &para;
+	tr[1].len = 1;
+	tr[1].speed_hz = 10000000;
+	tr[1].tx_nbits = 1;
+	tr[1].rx_nbits = 1;
+
+	spi_message_init(&msg);
+	spi_message_add_tail(&tr[0], &msg);
+	spi_message_add_tail(&tr[1], &msg);
+	return spi_sync(p_lcd->spi_device, &msg);
+}
+
+static int
+sunxi_lcd_fb_disp_qspi_lcd_multi_para_write(struct sunxi_lcd_fb_device *p_lcd,
+					    unsigned char cmd,
+					    unsigned char *tx_buf, u32 len)
+{
+	struct spi_message msg;
+	struct spi_transfer tr[2];
+	struct disp_lcd_private_data *lcdp =
+		sunxi_lcd_fb_disp_lcd_get_priv(p_lcd);
+	unsigned char addr_buf[4] = { 0x02, 0x00, cmd, 0x00 };
+
+	if (!p_lcd || !p_lcd->spi_device)
+		return -1;
+
+	memset(&tr, 0, sizeof(struct spi_transfer) * 2);
+
+	sunxi_lcd_fb_spi_dc_pin_set(lcdp, 1);
+
+	tr[0].tx_buf = addr_buf;
+	tr[0].len = 4;
+	tr[0].speed_hz = 10000000;
+	tr[0].tx_nbits = 1;
+	tr[0].rx_nbits = 1;
+
+	tr[1].tx_buf = tx_buf;
+	tr[1].len = len;
+	tr[1].speed_hz = 10000000;
+	tr[1].tx_nbits = 1;
+	tr[1].rx_nbits = 1;
+
+	spi_message_init(&msg);
+	spi_message_add_tail(&tr[0], &msg);
+	spi_message_add_tail(&tr[1], &msg);
+	return spi_sync(p_lcd->spi_device, &msg);
+}
+
+static int sunxi_lcd_fb_disp_lcd_cmd_write(struct sunxi_lcd_fb_device *p_lcd,
+					   unsigned char cmd)
 {
 	struct spi_transfer t;
+#if defined(SUPPORT_DBI_IF)
 	struct sunxi_dbi_config dbi_config;
-	struct disp_lcd_private_data *lcdp = disp_lcd_get_priv(p_lcd);
+#endif
+	struct disp_lcd_private_data *lcdp =
+		sunxi_lcd_fb_disp_lcd_get_priv(p_lcd);
 
 	if (!p_lcd || !p_lcd->spi_device)
 		return -1;
@@ -1817,42 +2348,78 @@ static int disp_lcd_cmd_write(struct lcd_fb_device *p_lcd, unsigned char cmd)
 #if defined(SUPPORT_DBI_IF)
 	memset(&dbi_config, 0, sizeof(dbi_config));
 	if (lcdp->panel_info.lcd_if == LCD_FB_IF_DBI) {
-		spi_dbi_config_init(lcdp, &dbi_config);
+		sunxi_lcd_fb_spi_dbi_config_init(lcdp, &dbi_config);
 		DBI_WRITE(dbi_config.dbi_mode);
 		DBI_MSB_FIRST(dbi_config.dbi_mode);
 		DBI_TR_COMMAND(dbi_config.dbi_mode);
 		DBI_DCX_COMMAND(dbi_config.dbi_mode);
-		dbi_config.dbi_format = 0;	/* must set rgb111 */
+		dbi_config.dbi_format = 0; /* must set rgb111 */
 		sunxi_dbi_set_config(p_lcd->spi_device, &dbi_config);
 	} else
 #endif
 	{
-		_spi_dc_pin_set(lcdp, 0);
+		sunxi_lcd_fb_spi_dc_pin_set(lcdp, 0);
 	}
 	memset(&t, 0, sizeof(t));
 
-	t.tx_buf 	= &cmd;
-	t.len		= 1;
+	t.tx_buf = &cmd;
+	t.len = 1;
 	t.speed_hz = 20000000;
 
 	spi_sync_transfer(p_lcd->spi_device, &t, 1);
 	/* restore to transfer data */
 	if (lcdp->panel_info.lcd_if == LCD_FB_IF_SPI)
-		_spi_dc_pin_set(lcdp, 1);
+		sunxi_lcd_fb_spi_dc_pin_set(lcdp, 1);
 	return 0;
 }
 
-s32 disp_init_lcd(struct dev_lcd_fb_t *p_info)
+static int
+sunxi_lcd_fb_disp_qspi_lcd_cmd_write(struct sunxi_lcd_fb_device *p_lcd,
+				     unsigned char cmd)
+{
+	struct spi_transfer t;
+	struct disp_lcd_private_data *lcdp =
+		sunxi_lcd_fb_disp_lcd_get_priv(p_lcd);
+	unsigned char addr_buf[4] = { 0x02, 0x00, cmd, 0x00 };
+
+	if (!p_lcd || !p_lcd->spi_device)
+		return -1;
+
+	sunxi_lcd_fb_spi_dc_pin_set(lcdp, 0);
+
+	memset(&t, 0, sizeof(struct spi_transfer));
+
+	t.tx_buf = addr_buf;
+	t.len = 4;
+	t.speed_hz = 5000000;
+	t.tx_nbits = 1;
+	t.rx_nbits = 1;
+
+	spi_sync_transfer(p_lcd->spi_device, &t, 1);
+	sunxi_lcd_fb_spi_dc_pin_set(lcdp, 1);
+	return 0;
+}
+
+#if (LINUX_VERSION_CODE >= KERNEL_VERSION(6, 6, 0))
+static struct spi_device *of_find_spi_device_by_node(struct device_node *node)
+{
+	struct device *dev = bus_find_device_by_of_node(&spi_bus_type, node);
+	return dev ? to_spi_device(dev) : NULL;
+}
+#endif
+
+s32 sunxi_lcd_fb_disp_init_lcd(struct sunxi_lcd_fb_dev_lcd_fb_t *p_info)
 {
 	u32 disp = 0;
-	struct lcd_fb_device *lcd;
+	struct sunxi_lcd_fb_device *lcd;
 	struct disp_lcd_private_data *lcdp;
-	u32 hwdev_index = 0;
-	u32 num_devices_support_lcd = SUPPORT_MAX_LCD;
-	char primary_key[20];
+	struct device_node *endpoint_np = NULL, *panel_node = NULL;
+	struct spi_device *spi;
+	struct device_node *np = p_info->device->of_node;
+	u32 hwdev_index = 0, i = 0;
 	int ret = 0, value = 1;
 
-	lcd_fb_inf("disp_init_lcd\n");
+	LCDFB_INF("sunxi_lcd_fb_disp_init_lcd\n");
 
 	spin_lock_init(&lcd_data_lock);
 
@@ -1860,87 +2427,139 @@ s32 disp_init_lcd(struct dev_lcd_fb_t *p_info)
 		kfree(lcds);
 		lcds = NULL;
 	}
-	lcds =
-	    kmalloc_array(num_devices_support_lcd, sizeof(*lcds),
-			  GFP_KERNEL | __GFP_ZERO);
+
+	lcds = kmalloc_array(p_info->lcd_panel_count, sizeof(*lcds),
+			     GFP_KERNEL | __GFP_ZERO);
 	if (lcds == NULL) {
-		lcd_fb_wrn("malloc memory(%d bytes) fail!\n",
-		       (unsigned int)sizeof(struct lcd_fb_device) *
-		       num_devices_support_lcd);
+		LCDFB_WRN("malloc memory(%d bytes) fail!\n",
+			  (u32)sizeof(struct sunxi_lcd_fb_device) *
+				  p_info->lcd_panel_count);
 		goto malloc_err;
 	}
-	lcd_private =
-	    (struct disp_lcd_private_data *)
-	    kmalloc(sizeof(*lcd_private)
-		    * num_devices_support_lcd, GFP_KERNEL | __GFP_ZERO);
+
+	lcd_private = (struct disp_lcd_private_data *)kmalloc(
+		sizeof(*lcd_private) * p_info->lcd_panel_count,
+		GFP_KERNEL | __GFP_ZERO);
+
 	if (lcd_private == NULL) {
-		lcd_fb_wrn("malloc memory(%d bytes) fail!\n",
-		       (unsigned int)sizeof(struct disp_lcd_private_data) *
-		       num_devices_support_lcd);
+		LCDFB_WRN("malloc memory(%d bytes) fail!\n",
+			  (u32)sizeof(struct disp_lcd_private_data) *
+				  p_info->lcd_panel_count);
 		goto malloc_err;
 	}
 
 	disp = 0;
-	for (hwdev_index = 0; hwdev_index < num_devices_support_lcd; hwdev_index++) {
+	for (hwdev_index = 0; hwdev_index < p_info->lcd_panel_count;
+	     hwdev_index++) {
+		endpoint_np = of_graph_get_endpoint_by_regs(np, 0, hwdev_index);
+		if (!endpoint_np) {
+			LCDFB_WRN("failed to get endpoint %d\n", i);
+			continue;
+		}
+		panel_node = of_graph_get_remote_endpoint(endpoint_np);
+		if (!panel_node) {
+			of_node_put(endpoint_np);
+			LCDFB_WRN("failed to get endpoint%d node\n",
+				  hwdev_index);
+			continue;
+		}
+
+		/* check panel is used */
+		ret = sunxi_lcd_fb_script_get_item(panel_node, "lcd_used",
+						   &value, 1);
+		if (ret != 1 || value != 1) {
+			of_node_put(endpoint_np);
+			LCDFB_INF("sunxi_lcd_fb_script_get_item %d value %d\n",
+				  ret, value);
+			continue;
+		}
 
-		sprintf(primary_key, "lcd_fb%d", disp);
-		ret = lcd_fb_script_get_item(primary_key, "lcd_used", &value,
-					       1);
-		if (ret != 1 || value != 1)
+		spi = of_find_spi_device_by_node(panel_node);
+		if (!spi) {
+			of_node_put(panel_node);
+			of_node_put(endpoint_np);
+			LCDFB_WRN(
+				"failed to obtain the spi device of panel%d\n",
+				hwdev_index);
 			continue;
+		}
+
+		LCDFB_INF("get spi panel %d, init for disp %d\n", hwdev_index,
+			  disp);
+
 		lcd = &lcds[disp];
 		lcdp = &lcd_private[disp];
 		lcd->priv_data = (void *)lcdp;
 		++p_info->lcd_fb_num;
 
+		lcd->panel_node = panel_node;
+		lcd->spi_device = spi;
+
 		sprintf(lcd->name, "lcd%d", disp);
 		lcd->disp = disp;
 		lcd->dev = p_info->device;
 
-		lcd->get_resolution = disp_lcd_get_resolution;
-		lcd->enable = disp_lcd_enable;
-		lcd->fake_enable = disp_lcd_fake_enable;
-		lcd->disable = disp_lcd_disable;
-		lcd->is_enabled = disp_lcd_is_enabled;
-		lcd->set_bright = disp_lcd_set_bright;
-		lcd->get_bright = disp_lcd_get_bright;
-		lcd->set_bright_dimming = disp_lcd_set_bright_dimming;
-		lcd->get_panel_info = disp_lcd_get_panel_info;
-
-		lcd->set_panel_func = disp_lcd_set_panel_funs;
-		lcd->set_open_func = disp_lcd_set_open_func;
-		lcd->set_close_func = disp_lcd_set_close_func;
-		lcd->backlight_enable = disp_lcd_backlight_enable;
-		lcd->backlight_disable = disp_lcd_backlight_disable;
-		lcd->pwm_enable = disp_lcd_pwm_enable;
-		lcd->pwm_disable = disp_lcd_pwm_disable;
-		lcd->power_enable = disp_lcd_power_enable;
-		lcd->power_disable = disp_lcd_power_disable;
-		lcd->pin_cfg = disp_lcd_pin_cfg;
-		lcd->gpio_set_value = disp_lcd_gpio_set_value;
-		lcd->gpio_set_direction = disp_lcd_gpio_set_direction;
-		lcd->get_dimensions = disp_lcd_get_dimensions;
-		lcd->set_gamma_tbl = disp_lcd_set_gamma_tbl;
-		lcd->enable_gamma = disp_lcd_enable_gamma;
-		lcd->disable_gamma = disp_lcd_disable_gamma;
-		lcd->set_color_temperature = disp_lcd_set_color_temperature;
-		lcd->get_color_temperature = disp_lcd_get_color_temperature;
-		lcd->set_layer = disp_lcd_set_layer;
-		lcd->blank = disp_lcd_blank;
-		lcd->set_var = disp_lcd_set_var;
-		lcd->para_write = disp_lcd_para_write;
-		lcd->cmd_write = disp_lcd_cmd_write;
-		lcd->cmd_read = disp_lcd_cmd_read;
-		lcd->wait_for_vsync = disp_lcd_wait_for_vsync;
-
-
-		lcd->init = disp_lcd_init;
-		lcd->exit = disp_lcd_exit;
+		lcd->get_resolution = sunxi_lcd_fb_disp_lcd_get_resolution;
+		lcd->enable = sunxi_lcd_fb_disp_lcd_enable;
+		lcd->fake_enable = sunxi_lcd_fb_disp_lcd_fake_enable;
+		lcd->disable = sunxi_lcd_fb_disp_lcd_disable;
+		lcd->is_enabled = sunxi_lcd_fb_disp_lcd_is_enabled;
+		lcd->set_bright = sunxi_lcd_fb_disp_lcd_set_bright;
+		lcd->get_bright = sunxi_lcd_fb_disp_lcd_get_bright;
+		lcd->set_bright_dimming =
+			sunxi_lcd_fb_disp_lcd_set_bright_dimming;
+		lcd->get_panel_info = sunxi_lcd_fb_disp_lcd_get_panel_info;
+
+		lcd->set_panel_func = sunxi_lcd_fb_disp_lcd_set_panel_funs;
+		lcd->set_open_func = sunxi_lcd_fb_disp_lcd_set_open_func;
+		lcd->set_close_func = sunxi_lcd_fb_disp_lcd_set_close_func;
+		lcd->backlight_enable = sunxi_lcd_fb_disp_lcd_backlight_enable;
+		lcd->backlight_disable =
+			sunxi_lcd_fb_disp_lcd_backlight_disable;
+		lcd->pwm_enable = sunxi_lcd_fb_disp_lcd_pwm_enable;
+		lcd->pwm_disable = sunxi_lcd_fb_disp_lcd_pwm_disable;
+		lcd->power_enable = sunxi_lcd_fb_disp_lcd_power_enable;
+		lcd->power_disable = sunxi_lcd_fb_disp_lcd_power_disable;
+		lcd->pin_cfg = sunxi_lcd_fb_disp_lcd_pin_cfg;
+		lcd->gpio_set_value = sunxi_lcd_fb_disp_lcd_gpio_set_value;
+		lcd->gpio_set_direction =
+			sunxi_lcd_fb_disp_lcd_gpio_set_direction;
+		lcd->get_dimensions = sunxi_lcd_fb_disp_lcd_get_dimensions;
+		lcd->set_gamma_tbl = sunxi_lcd_fb_disp_lcd_set_gamma_tbl;
+		lcd->enable_gamma = sunxi_lcd_fb_disp_lcd_enable_gamma;
+		lcd->disable_gamma = sunxi_lcd_fb_disp_lcd_disable_gamma;
+		lcd->set_color_temperature =
+			sunxi_lcd_fb_disp_lcd_set_color_temperature;
+		lcd->get_color_temperature =
+			sunxi_lcd_fb_disp_lcd_get_color_temperature;
+		lcd->blank = sunxi_lcd_fb_disp_lcd_blank;
+		lcd->set_var = sunxi_lcd_fb_disp_lcd_set_var;
+		lcd->para_write = sunxi_lcd_fb_disp_lcd_para_write;
+		lcd->cmd_write = sunxi_lcd_fb_disp_lcd_cmd_write;
+		lcd->cmd_read = sunxi_lcd_fb_disp_lcd_cmd_read;
+		lcd->qspi_para_write = sunxi_lcd_fb_disp_qspi_lcd_para_write;
+		lcd->qspi_multi_para_write =
+			sunxi_lcd_fb_disp_qspi_lcd_multi_para_write;
+		lcd->qspi_cmd_write = sunxi_lcd_fb_disp_qspi_lcd_cmd_write;
+		lcd->qspi_cmd_read = sunxi_lcd_fb_disp_qspi_lcd_cmd_read;
+		lcd->wait_for_vsync = sunxi_lcd_fb_disp_lcd_wait_for_vsync;
+
+		lcd->init = sunxi_lcd_fb_disp_lcd_init;
+		lcd->exit = sunxi_lcd_fb_disp_lcd_exit;
 
 		lcd->init(lcd);
-		lcd_fb_device_register(lcd);
+
+		if (lcdp->panel_info.lcd_if == LCD_FB_IF_QSPI)
+			lcd->set_layer = sunxi_lcd_fb_disp_qspi_lcd_set_layer;
+		else
+			lcd->set_layer = sunxi_lcd_fb_disp_spi_lcd_set_layer;
+
+		sunxi_sunxi_lcd_fb_device_register(lcd);
 
 		disp++;
+
+		of_node_put(panel_node);
+		of_node_put(endpoint_np);
 	}
 
 	return 0;
@@ -1954,27 +2573,22 @@ malloc_err:
 	return -1;
 }
 
-s32 disp_exit_lcd(void)
+s32 sunxi_lcd_fb_disp_exit_lcd(void)
 {
 	u32 hwdev_index = 0, disp = 0;
-	char primary_key[20];
-	int ret = 0, value = 1;
-	struct lcd_fb_device *lcd;
+	struct sunxi_lcd_fb_device *lcd;
 
 	if (!lcds)
 		return 0;
 
-	for (hwdev_index = 0; hwdev_index < SUPPORT_MAX_LCD; hwdev_index++) {
-		sprintf(primary_key, "lcd_fb%d", disp);
-		ret =
-		    lcd_fb_script_get_item(primary_key, "lcd_used", &value, 1);
-		if (ret != 1 || value != 1)
-			continue;
-
+	for (hwdev_index = 0; hwdev_index < g_drv_info.lcd_panel_count;
+	     hwdev_index++) {
 		lcd = &lcds[disp];
-		lcd_fb_device_unregister(lcd);
-		lcd->exit(lcd);
-		disp++;
+		if (lcd) {
+			sunxi_sunxi_lcd_fb_device_unregister(lcd);
+			lcd->exit(lcd);
+			disp++;
+		}
 	}
 
 	kfree(lcds);
diff --git a/drivers/video/sunxi/lcd_fb/disp_lcd.h b/drivers/video/sunxi/lcd_fb/disp_lcd.h
index 117b7171a..c1a7f0cb2 100644
--- a/drivers/video/sunxi/lcd_fb/disp_lcd.h
+++ b/drivers/video/sunxi/lcd_fb/disp_lcd.h
@@ -1,4 +1,4 @@
-/* SPDX-License-Identifier: GPL-2.0-or-later */
+// SPDX-License-Identifier: GPL-2.0-or-later
 /* Copyright(c) 2020 - 2023 Allwinner Technology Co.,Ltd. All rights reserved. */
 /*
  * Allwinner SoCs display driver.
@@ -10,23 +10,21 @@
  * warranty of any kind, whether express or implied.
  */
 
+#ifndef __DISP_LCD_H__
+#define __DISP_LCD_H__
 
 #include "include.h"
 #include "lcd_fb_intf.h"
 #include "dev_lcd_fb.h"
-#ifndef __DISP_LCD_H__
-#define __DISP_LCD_H__
 
-
-#define SUPPORT_MAX_LCD LCD_FB_MAX
 #define LCD_GPIO_NUM 8
 #define LCD_POWER_NUM 4
 #define LCD_POWER_STR_LEN 32
 #define LCD_GPIO_REGU_NUM 3
-#define LCD_GPIO_SCL (LCD_GPIO_NUM-2)
-#define LCD_GPIO_SDA (LCD_GPIO_NUM-1)
+#define LCD_GPIO_SCL (LCD_GPIO_NUM - 2)
+#define LCD_GPIO_SDA (LCD_GPIO_NUM - 1)
 
-struct disp_lcd_cfg {
+struct sunxi_lcd_fb_disp_lcd_cfg {
 	bool lcd_used;
 
 	bool lcd_bl_en_used;
@@ -64,17 +62,30 @@ struct disp_lcd_cfg {
 	u32 lcd_hue;
 };
 
-s32 disp_init_lcd(struct dev_lcd_fb_t *p_info);
-s32 disp_exit_lcd(void);
-s32 disp_lcd_set_bright(struct lcd_fb_device *lcd, u32 bright);
-s32 disp_lcd_get_bright(struct lcd_fb_device *lcd);
-s32 disp_lcd_gpio_init(struct lcd_fb_device *lcd);
-s32 disp_lcd_gpio_exit(struct lcd_fb_device *lcd);
-s32 disp_lcd_gpio_set_direction(struct lcd_fb_device *lcd, u32 io_index,
-				u32 direction);
-s32 disp_lcd_gpio_get_value(struct lcd_fb_device *lcd, u32 io_index);
-s32 disp_lcd_gpio_set_value(struct lcd_fb_device *lcd, u32 io_index, u32 data);
-s32 disp_lcd_is_enabled(struct lcd_fb_device *lcd);
-struct lcd_fb_device *disp_get_lcd(u32 disp);
+s32 sunxi_lcd_fb_disp_init_lcd(struct sunxi_lcd_fb_dev_lcd_fb_t *p_info);
+
+s32 sunxi_lcd_fb_disp_exit_lcd(void);
+
+s32 sunxi_lcd_fb_disp_lcd_set_bright(struct sunxi_lcd_fb_device *lcd,
+				     u32 bright);
+
+s32 sunxi_lcd_fb_disp_lcd_get_bright(struct sunxi_lcd_fb_device *lcd);
+
+s32 sunxi_lcd_fb_disp_lcd_gpio_init(struct sunxi_lcd_fb_device *lcd);
+
+s32 sunxi_lcd_fb_disp_lcd_gpio_exit(struct sunxi_lcd_fb_device *lcd);
+
+s32 sunxi_lcd_fb_disp_lcd_gpio_set_direction(struct sunxi_lcd_fb_device *lcd,
+					     u32 io_index, u32 direction);
+
+s32 sunxi_lcd_fb_disp_lcd_gpio_get_value(struct sunxi_lcd_fb_device *lcd,
+					 u32 io_index);
+
+s32 sunxi_lcd_fb_disp_lcd_gpio_set_value(struct sunxi_lcd_fb_device *lcd,
+					 u32 io_index, u32 data);
+
+s32 sunxi_lcd_fb_disp_lcd_is_enabled(struct sunxi_lcd_fb_device *lcd);
+
+struct sunxi_lcd_fb_device *sunxi_lcd_fb_disp_get_lcd(u32 disp);
 
 #endif
